blob: 3789992fae4ed74cd29f229c646119342d5f76f5 [file] [log] [blame]
garciadeblas16304ba2016-05-11 14:47:39 +02001#!/bin/bash
2
3##
tierno92021022018-09-12 16:29:23 +02004# Copyright 2015 Telefonica Investigacion y Desarrollo, S.A.U.
garciadeblas16304ba2016-05-11 14:47:39 +02005# This file is part of openmano
6# All Rights Reserved.
7#
8# Licensed under the Apache License, Version 2.0 (the "License"); you may
9# not use this file except in compliance with the License. You may obtain
10# a copy of the License at
11#
12# http://www.apache.org/licenses/LICENSE-2.0
13#
14# Unless required by applicable law or agreed to in writing, software
15# distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
16# WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
17# License for the specific language governing permissions and limitations
18# under the License.
19#
20# For those usages not covered by the Apache License, Version 2.0 please
21# contact with: nfvlabs@tid.es
22##
23
tierno76841842016-09-27 09:18:28 +000024#ONLY TESTED in Ubuntu 16.04 partially tested in Ubuntu 14.10 14.04 16.04, CentOS7 and RHEL7
garciadeblas16304ba2016-05-11 14:47:39 +020025#Get needed packages, source code and configure to run openmano
26#Ask for database user and password if not provided
garciadeblas16304ba2016-05-11 14:47:39 +020027
28function usage(){
Igor D.Cbf669b92017-10-23 13:36:03 +000029 echo -e "usage: sudo -E $0 [OPTIONS]"
tierno45a52852016-08-26 14:39:42 +020030 echo -e "Install last stable source code in ./openmano and the needed packages"
31 echo -e "On a Ubuntu 16.04 it configures openmano as a service"
tiernoc50e5da2016-07-06 17:49:45 +020032 echo -e " OPTIONS"
tierno45a52852016-08-26 14:39:42 +020033 echo -e " -u USER: database admin user. 'root' by default. Prompts if needed"
34 echo -e " -p PASS: database admin password to be used or installed. Prompts if needed"
garciadeblas89b3d842016-09-19 15:18:33 +020035 echo -e " -q --quiet: install in unattended mode"
tierno45a52852016-08-26 14:39:42 +020036 echo -e " -h --help: show this help"
tiernoedaf0c32017-11-02 11:41:19 +010037 echo -e " -b REFSPEC: install from source code using a specific branch (master, v2.0, ...) or tag"
38 echo -e " -b master (main RO branch)"
39 echo -e " -b v2.0 (v2.0 branch)"
40 echo -e " -b tags/v1.1.0 (a specific tag)"
41 echo -e " ..."
tierno45a52852016-08-26 14:39:42 +020042 echo -e " --develop: install last version for developers, and do not configure as a service"
tierno26777652016-11-15 17:33:13 +000043 echo -e " --forcedb: reinstall mano_db DB, deleting previous database if exists and creating a new one"
tierno80fde982017-04-26 14:33:25 +020044 echo -e " --updatedb: do not reinstall mano_db DB if it exists, just update database"
tierno443c84a2017-04-24 12:31:33 +020045 echo -e " --force: makes idenpotent, delete previous installations folders if needed. It assumes --updatedb if --forcedb option is not provided"
garciadeblas89b3d842016-09-19 15:18:33 +020046 echo -e " --noclone: assumes that openmano was cloned previously and that this script is run from the local repo"
tierno76841842016-09-27 09:18:28 +000047 echo -e " --no-install-packages: use this option to skip updating and installing the requires packages. This avoid wasting time if you are sure requires packages are present e.g. because of a previous installation"
garciadeblas5b1a6642017-04-18 10:10:31 +020048 echo -e " --no-db: do not install mysql server"
garciadeblas16304ba2016-05-11 14:47:39 +020049}
50
51function install_packages(){
52 [ -x /usr/bin/apt-get ] && apt-get install -y $*
tiernoc50e5da2016-07-06 17:49:45 +020053 [ -x /usr/bin/yum ] && yum install -y $*
garciadeblas16304ba2016-05-11 14:47:39 +020054
55 #check properly installed
56 for PACKAGE in $*
57 do
58 PACKAGE_INSTALLED="no"
59 [ -x /usr/bin/apt-get ] && dpkg -l $PACKAGE &>> /dev/null && PACKAGE_INSTALLED="yes"
60 [ -x /usr/bin/yum ] && yum list installed $PACKAGE &>> /dev/null && PACKAGE_INSTALLED="yes"
61 if [ "$PACKAGE_INSTALLED" = "no" ]
62 then
tiernoc50e5da2016-07-06 17:49:45 +020063 echo "failed to install package '$PACKAGE'. Revise network connectivity and try again" >&2
garciadeblas89b3d842016-09-19 15:18:33 +020064 exit 1
garciadeblas16304ba2016-05-11 14:47:39 +020065 fi
66 done
67}
68
tierno80fde982017-04-26 14:33:25 +020069function ask_user(){
70 # ask to the user and parse a response among 'y', 'yes', 'n' or 'no'. Case insensitive
71 # Params: $1 text to ask; $2 Action by default, can be 'y' for yes, 'n' for no, other or empty for not allowed
72 # Return: true(0) if user type 'yes'; false (1) if user type 'no'
73 read -e -p "$1" USER_CONFIRMATION
74 while true ; do
75 [ -z "$USER_CONFIRMATION" ] && [ "$2" == 'y' ] && return 0
76 [ -z "$USER_CONFIRMATION" ] && [ "$2" == 'n' ] && return 1
77 [ "${USER_CONFIRMATION,,}" == "yes" ] || [ "${USER_CONFIRMATION,,}" == "y" ] && return 0
78 [ "${USER_CONFIRMATION,,}" == "no" ] || [ "${USER_CONFIRMATION,,}" == "n" ] && return 1
79 read -e -p "Please type 'yes' or 'no': " USER_CONFIRMATION
80 done
81}
82
tierno45a52852016-08-26 14:39:42 +020083GIT_URL=https://osm.etsi.org/gerrit/osm/RO.git
tiernoa7f744d2018-09-10 11:04:31 +020084export GIT_OVIM_URL=https://osm.etsi.org/gerrit/osm/openvim.git
85export GIT_OSMIM_URL=https://osm.etsi.org/gerrit/osm/IM.git
tiernoc50e5da2016-07-06 17:49:45 +020086DBUSER="root"
87DBPASSWD=""
88DBPASSWD_PARAM=""
89QUIET_MODE=""
tierno45a52852016-08-26 14:39:42 +020090DEVELOP=""
tierno443c84a2017-04-24 12:31:33 +020091DB_FORCE_UPDATE=""
92UPDATEDB=""
tierno26777652016-11-15 17:33:13 +000093FORCE=""
garciadeblas89b3d842016-09-19 15:18:33 +020094NOCLONE=""
tierno76841842016-09-27 09:18:28 +000095NO_PACKAGES=""
Gennadiy Dubina89cb0d12017-04-03 15:46:41 +030096NO_DB=""
tiernoedaf0c32017-11-02 11:41:19 +010097COMMIT_ID=""
tierno80fde982017-04-26 14:33:25 +020098
tiernoedaf0c32017-11-02 11:41:19 +010099while getopts ":u:p:b:hiq-:" o; do
tiernoc50e5da2016-07-06 17:49:45 +0200100 case "${o}" in
101 u)
102 export DBUSER="$OPTARG"
103 ;;
104 p)
105 export DBPASSWD="$OPTARG"
106 export DBPASSWD_PARAM="-p$OPTARG"
107 ;;
tiernoedaf0c32017-11-02 11:41:19 +0100108 b)
109 export COMMIT_ID=${OPTARG}
110 ;;
tiernoc50e5da2016-07-06 17:49:45 +0200111 q)
112 export QUIET_MODE=yes
113 export DEBIAN_FRONTEND=noninteractive
114 ;;
115 h)
116 usage && exit 0
117 ;;
118 -)
119 [ "${OPTARG}" == "help" ] && usage && exit 0
tiernoa7f744d2018-09-10 11:04:31 +0200120 [ "${OPTARG}" == "develop" ] && export DEVELOP="y" && continue
tierno443c84a2017-04-24 12:31:33 +0200121 [ "${OPTARG}" == "forcedb" ] && DB_FORCE_UPDATE="${DB_FORCE_UPDATE}--forcedb" && continue
122 [ "${OPTARG}" == "updatedb" ] && DB_FORCE_UPDATE="${DB_FORCE_UPDATE}--updatedb" && continue
123 [ "${OPTARG}" == "force" ] && FORCE="y" && continue
garciadeblas89b3d842016-09-19 15:18:33 +0200124 [ "${OPTARG}" == "noclone" ] && NOCLONE="y" && continue
tierno45a52852016-08-26 14:39:42 +0200125 [ "${OPTARG}" == "quiet" ] && export QUIET_MODE=yes && export DEBIAN_FRONTEND=noninteractive && continue
tierno76841842016-09-27 09:18:28 +0000126 [ "${OPTARG}" == "no-install-packages" ] && export NO_PACKAGES=yes && continue
Gennadiy Dubina89cb0d12017-04-03 15:46:41 +0300127 [ "${OPTARG}" == "no-db" ] && NO_DB="y" && continue
tierno80fde982017-04-26 14:33:25 +0200128 echo -e "Invalid option: '--$OPTARG'\nTry $0 --help for more information" >&2
tiernoc50e5da2016-07-06 17:49:45 +0200129 exit 1
tierno80fde982017-04-26 14:33:25 +0200130 ;;
tiernoc50e5da2016-07-06 17:49:45 +0200131 \?)
132 echo -e "Invalid option: '-$OPTARG'\nTry $0 --help for more information" >&2
133 exit 1
134 ;;
135 :)
136 echo -e "Option '-$OPTARG' requires an argument\nTry $0 --help for more information" >&2
137 exit 1
138 ;;
139 *)
140 usage >&2
garciadeblas89b3d842016-09-19 15:18:33 +0200141 exit 1
tiernoc50e5da2016-07-06 17:49:45 +0200142 ;;
143 esac
144done
garciadeblas16304ba2016-05-11 14:47:39 +0200145
tierno443c84a2017-04-24 12:31:33 +0200146if [ "$DB_FORCE_UPDATE" == "--forcedb--updatedb" ] || [ "$DB_FORCE_UPDATE" == "--updatedb--forcedb" ] ; then
147 echo "Error: options --forcedb and --updatedb are mutually exclusive" >&2
148 exit 1
149elif [ -n "$FORCE" ] && [ -z "$DB_FORCE_UPDATE" ] ; then
150 DB_FORCE_UPDATE="--updatedb"
151fi
152
tiernoc50e5da2016-07-06 17:49:45 +0200153#check root privileges and non a root user behind
garciadeblas89b3d842016-09-19 15:18:33 +0200154[ "$USER" != "root" ] && echo "Needed root privileges" >&2 && exit 1
tiernoc50e5da2016-07-06 17:49:45 +0200155if [[ -z "$SUDO_USER" ]] || [[ "$SUDO_USER" = "root" ]]
156then
tierno80fde982017-04-26 14:33:25 +0200157 [[ -z $QUIET_MODE ]] && ! ask_user "Install in the root user (y/N)? " n && echo "Cancelled" && exit 1
tiernoc50e5da2016-07-06 17:49:45 +0200158 export SUDO_USER=root
159fi
garciadeblas16304ba2016-05-11 14:47:39 +0200160
tierno80fde982017-04-26 14:33:25 +0200161# Discover Linux distribution
162# try redhat type
garciadeblas16304ba2016-05-11 14:47:39 +0200163[ -f /etc/redhat-release ] && _DISTRO=$(cat /etc/redhat-release 2>/dev/null | cut -d" " -f1)
tierno80fde982017-04-26 14:33:25 +0200164# if not assuming ubuntu type
garciadeblas16304ba2016-05-11 14:47:39 +0200165[ -f /etc/redhat-release ] || _DISTRO=$(lsb_release -is 2>/dev/null)
166if [ "$_DISTRO" == "Ubuntu" ]
167then
tierno45a52852016-08-26 14:39:42 +0200168 _RELEASE=$(lsb_release -rs)
tierno070e95f2017-05-05 15:55:13 +0200169 if [[ ${_RELEASE%%.*} != 14 ]] && [[ ${_RELEASE%%.*} != 16 ]]
170 then
tierno80fde982017-04-26 14:33:25 +0200171 [[ -z $QUIET_MODE ]] &&
172 ! ask_user "WARNING! Not tested Ubuntu version. Continue assuming a trusty (14.XX)' (y/N)? " n &&
173 echo "Cancelled" && exit 1
tierno45a52852016-08-26 14:39:42 +0200174 _RELEASE = 14
garciadeblas16304ba2016-05-11 14:47:39 +0200175 fi
176elif [ "$_DISTRO" == "CentOS" ]
177then
178 _RELEASE="7"
179 if ! cat /etc/redhat-release | grep -q "7."
180 then
tierno80fde982017-04-26 14:33:25 +0200181 [[ -z $QUIET_MODE ]] &&
182 ! ask_user "WARNING! Not tested CentOS version. Continue assuming a '$_RELEASE' type (y/N)? " n &&
183 echo "Cancelled" && exit 1
garciadeblas16304ba2016-05-11 14:47:39 +0200184 fi
185elif [ "$_DISTRO" == "Red" ]
186then
187 _RELEASE="7"
188 if ! cat /etc/redhat-release | grep -q "7."
189 then
tierno80fde982017-04-26 14:33:25 +0200190 [[ -z $QUIET_MODE ]] &&
191 ! ask_user "WARNING! Not tested Red Hat OS version. Continue assuming a '$_RELEASE' type (y/N)? " n &&
192 echo "Cancelled" && exit 1
garciadeblas16304ba2016-05-11 14:47:39 +0200193 fi
194else #[ "$_DISTRO" != "Ubuntu" -a "$_DISTRO" != "CentOS" -a "$_DISTRO" != "Red" ]
195 _DISTRO_DISCOVER=$_DISTRO
196 [ -x /usr/bin/apt-get ] && _DISTRO="Ubuntu" && _RELEASE="14"
197 [ -x /usr/bin/yum ] && _DISTRO="CentOS" && _RELEASE="7"
tierno80fde982017-04-26 14:33:25 +0200198 [[ -z $QUIET_MODE ]] &&
199 ! ask_user "WARNING! Not tested Linux distribution '$_DISTRO_DISCOVER '. Continue assuming a '$_DISTRO $_RELEASE' type (y/N)? " n &&
200 echo "Cancelled" && exit 1
garciadeblas16304ba2016-05-11 14:47:39 +0200201fi
202
tiernoa7f744d2018-09-10 11:04:31 +0200203export _DISTRO="$_DISTRO"
tierno26777652016-11-15 17:33:13 +0000204#check if installed as a service
205INSTALL_AS_A_SERVICE=""
206[[ "$_DISTRO" == "Ubuntu" ]] && [[ ${_RELEASE%%.*} == 16 ]] && [[ -z $DEVELOP ]] && INSTALL_AS_A_SERVICE="y"
tierno80fde982017-04-26 14:33:25 +0200207
208# Next operations require knowing BASEFOLDER
tierno26777652016-11-15 17:33:13 +0000209if [[ -z "$NOCLONE" ]]; then
tiernoaa5832d2016-12-07 16:20:25 +0100210 if [[ -n "$INSTALL_AS_A_SERVICE" ]] ; then
tiernoa7f744d2018-09-10 11:04:31 +0200211 export BASEFOLDER=__openmano__${RANDOM}
tiernoaa5832d2016-12-07 16:20:25 +0100212 else
tiernoa7f744d2018-09-10 11:04:31 +0200213 export BASEFOLDER="${PWD}/openmano"
tiernoaa5832d2016-12-07 16:20:25 +0100214 fi
tierno070e95f2017-05-05 15:55:13 +0200215 [[ -n "$FORCE" ]] && rm -rf $BASEFOLDER #make idempotent
tierno26777652016-11-15 17:33:13 +0000216else
tierno070e95f2017-05-05 15:55:13 +0200217 HERE=$(dirname $(readlink -f ${BASH_SOURCE[0]}))
tiernoa7f744d2018-09-10 11:04:31 +0200218 export BASEFOLDER=$(dirname $HERE)
tierno26777652016-11-15 17:33:13 +0000219fi
garciadeblas16304ba2016-05-11 14:47:39 +0200220
tierno80fde982017-04-26 14:33:25 +0200221if [[ -z "$NO_PACKAGES" ]]
tierno76841842016-09-27 09:18:28 +0000222then
tierno80fde982017-04-26 14:33:25 +0200223 echo -e "\n"\
224 "#################################################################\n"\
225 "##### UPDATE REPOSITORIES #####\n"\
226 "#################################################################"
tierno751a4ef2018-02-22 12:24:16 +0100227 [ "$_DISTRO" == "Ubuntu" ] && apt-get update -y &&
Eduardo Sousae3c0dbc2018-09-03 11:56:07 +0100228 add-apt-repository -y cloud-archive:queens && apt-get update -y
garciadeblas16304ba2016-05-11 14:47:39 +0200229
tierno80fde982017-04-26 14:33:25 +0200230 [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && yum check-update -y
Igor D.Cbf669b92017-10-23 13:36:03 +0000231 [ "$_DISTRO" == "CentOS" ] && yum install -y epel-release
tierno80fde982017-04-26 14:33:25 +0200232 [ "$_DISTRO" == "Red" ] && wget http://dl.fedoraproject.org/pub/epel/7/x86_64/e/epel-release-7-5.noarch.rpm \
Igor D.Cbf669b92017-10-23 13:36:03 +0000233 && rpm -ivh epel-release-7-5.noarch.rpm && yum install -y epel-release && rm -f epel-release-7-5.noarch.rpm
234 [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && yum repolist
garciadeblas16304ba2016-05-11 14:47:39 +0200235
tierno80fde982017-04-26 14:33:25 +0200236 echo -e "\n"\
237 "#################################################################\n"\
238 "##### INSTALL REQUIRED PACKAGES #####\n"\
239 "#################################################################"
240 [ "$_DISTRO" == "Ubuntu" ] && install_packages "git make screen wget mysql-client"
241 [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && install_packages "git make screen wget mariadb-client"
garciadeblas16304ba2016-05-11 14:47:39 +0200242
tierno80fde982017-04-26 14:33:25 +0200243 echo -e "\n"\
244 "#################################################################\n"\
245 "##### INSTALL PYTHON PACKAGES #####\n"\
246 "#################################################################"
tierno751a4ef2018-02-22 12:24:16 +0100247 [ "$_DISTRO" == "Ubuntu" ] && install_packages "python-yaml python-bottle python-mysqldb python-jsonschema "\
248 "python-paramiko python-argcomplete python-requests python-logutils libxml2-dev libxslt-dev python-dev "\
Anderson Bravalheri0446cd52018-08-17 15:26:19 +0100249 "python-pip python-crypto python-networkx"
tierno751a4ef2018-02-22 12:24:16 +0100250 [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && install_packages "PyYAML MySQL-python python-jsonschema "\
251 "python-paramiko python-argcomplete python-requests python-logutils libxslt-devel libxml2-devel python-devel "\
Anderson Bravalheri0446cd52018-08-17 15:26:19 +0100252 "python-pip python-crypto python-networkx"
tierno80fde982017-04-26 14:33:25 +0200253 # The only way to install python-bottle on Centos7 is with easy_install or pip
254 [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && easy_install -U bottle
garciadeblas16304ba2016-05-11 14:47:39 +0200255
tierno80fde982017-04-26 14:33:25 +0200256 # required for vmware connector TODO move that to separete opt in install script
tierno6082b7d2018-08-31 11:24:08 +0000257 pip2 install pip==9.0.3 || exit 1 # --upgrade pip install pip 10 that does not work
258 pip2 install pyvcloud==19.1.1 || exit 1
259 pip2 install progressbar || exit 1
260 pip2 install prettytable || exit 1
261 pip2 install pyvmomi || exit 1
bayramovfe3f3c92016-10-04 07:53:41 +0400262
jomacarpeea2a73e2018-02-27 13:48:22 +0100263 # required for OpenNebula connector
tierno6082b7d2018-08-31 11:24:08 +0000264 pip2 install untangle || exit 1
265 pip2 install -e git+https://github.com/python-oca/python-oca#egg=oca || exit 1
jomacarpeea2a73e2018-02-27 13:48:22 +0100266
tierno80fde982017-04-26 14:33:25 +0200267 # required for AWS connector
268 [ "$_DISTRO" == "Ubuntu" ] && install_packages "python-boto"
269 [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && install_packages "python-boto" #TODO check if at Centos it exists with this name, or PIP should be used
garciadeblas16304ba2016-05-11 14:47:39 +0200270
tierno80fde982017-04-26 14:33:25 +0200271 # install openstack client needed for using openstack as a VIM
tiernob4c22392017-06-14 12:55:38 +0200272 [ "$_DISTRO" == "Ubuntu" ] && install_packages "python-novaclient python-keystoneclient python-glanceclient "\
273 "python-neutronclient python-cinderclient python-openstackclient"
274 [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && install_packages "python-devel" && easy_install \
275 python-novaclient python-keystoneclient python-glanceclient python-neutronclient python-cinderclient \
276 python-openstackclient #TODO revise if gcc python-pip is needed
tierno80fde982017-04-26 14:33:25 +0200277fi # [[ -z "$NO_PACKAGES" ]]
garciadeblas16304ba2016-05-11 14:47:39 +0200278
garciadeblas89b3d842016-09-19 15:18:33 +0200279if [[ -z $NOCLONE ]]; then
tierno80fde982017-04-26 14:33:25 +0200280 echo -e "\n"\
281 "#################################################################\n"\
282 "##### DOWNLOAD SOURCE #####\n"\
283 "#################################################################"
tierno070e95f2017-05-05 15:55:13 +0200284 if [[ -d "${BASEFOLDER}" ]] ; then
tierno80fde982017-04-26 14:33:25 +0200285 if [[ -n "$FORCE" ]] ; then
tierno070e95f2017-05-05 15:55:13 +0200286 echo "deleting '${BASEFOLDER}' folder"
287 rm -rf "$BASEFOLDER" #make idempotent
tierno80fde982017-04-26 14:33:25 +0200288 elif [[ -z "$QUIET_MODE" ]] ; then
tierno070e95f2017-05-05 15:55:13 +0200289 ! ask_user "folder '${BASEFOLDER}' exists, overwrite (y/N)? " n && echo "Cancelled!" && exit 1
290 rm -rf "$BASEFOLDER"
tierno80fde982017-04-26 14:33:25 +0200291 else
tierno070e95f2017-05-05 15:55:13 +0200292 echo "'${BASEFOLDER}' folder exists. Use "--force" to overwrite" >&2 && exit 1
tierno80fde982017-04-26 14:33:25 +0200293 fi
294 fi
tiernoedaf0c32017-11-02 11:41:19 +0100295 su $SUDO_USER -c "git clone ${GIT_URL} ${BASEFOLDER}" || ! echo "Error cannot clone from '$GIT_URL'" >&2 || exit 1
296 if [[ -n $COMMIT_ID ]] ; then
297 echo -e "Installing osm-RO from refspec: $COMMIT_ID"
298 su $SUDO_USER -c "git -C ${BASEFOLDER} checkout $COMMIT_ID" ||
299 ! echo "Error cannot checkout '$COMMIT_ID' from '$GIT_URL'" >&2 || exit 1
300 elif [[ -z $DEVELOP ]]; then
301 LATEST_STABLE_TAG=`git -C "${BASEFOLDER}" tag -l "v[0-9]*" | sort -V | tail -n1`
302 echo -e "Installing osm-RO from refspec: tags/${LATEST_STABLE_TAG}"
303 su $SUDO_USER -c "git -C ${BASEFOLDER} checkout tags/${LATEST_STABLE_TAG}" ||
304 ! echo "Error cannot checkout 'tags/${LATEST_STABLE_TAG}' from '$GIT_URL'" >&2 || exit 1
305 else
306 echo -e "Installing osm-RO from refspec: master"
307 fi
tierno070e95f2017-05-05 15:55:13 +0200308 su $SUDO_USER -c "cp ${BASEFOLDER}/.gitignore-common ${BASEFOLDER}/.gitignore"
garciadeblas89b3d842016-09-19 15:18:33 +0200309fi
garciadeblas16304ba2016-05-11 14:47:39 +0200310
tierno80fde982017-04-26 14:33:25 +0200311echo -e "\n"\
312 "#################################################################\n"\
tierno4da1c242017-09-28 12:17:05 +0200313 "##### INSTALLING OSM-IM LIBRARY #####\n"\
314 "#################################################################"
tiernoa7f744d2018-09-10 11:04:31 +0200315 ${BASEFOLDER}/scripts/install-osm-im.sh
316 OSM_IM_PATH=`python -c 'import osm_im; print osm_im.__path__[0]'` ||
317 ! echo "ERROR installing python-osm-im library!!!" >&2 || exit 1
tierno4da1c242017-09-28 12:17:05 +0200318
319echo -e "\n"\
320 "#################################################################\n"\
tierno80fde982017-04-26 14:33:25 +0200321 "##### INSTALLING OVIM LIBRARY #####\n"\
322 "#################################################################"
tiernoa7f744d2018-09-10 11:04:31 +0200323 ${BASEFOLDER}/scripts/install-lib-osm-openvim.sh
324 OSMLIBOVIM_PATH=`python -c 'import lib_osm_openvim; print lib_osm_openvim.__path__[0]'` ||
325 ! echo "ERROR installing python-lib-osm-openvim library!!!" >&2 || exit 1
garciadeblasc53ebfa2017-03-31 16:02:13 +0200326
garciadeblas16304ba2016-05-11 14:47:39 +0200327if [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ]
328then
tierno80fde982017-04-26 14:33:25 +0200329 echo -e "\n"\
330 "#################################################################\n"\
331 "##### CONFIGURE firewalld #####\n"\
332 "#################################################################"
333 if [[ -z $QUIET_MODE ]] || ask_user "Configure firewalld for openmanod port 9090 (Y/n)? " y
garciadeblas16304ba2016-05-11 14:47:39 +0200334 then
335 #Creates a service file for openmano
336 echo '<?xml version="1.0" encoding="utf-8"?>
337<service>
338 <short>openmanod</short>
339 <description>openmanod service</description>
340 <port protocol="tcp" port="9090"/>
341</service>' > /etc/firewalld/services/openmanod.xml
342 #put proper permissions
343 pushd /etc/firewalld/services > /dev/null
344 restorecon openmanod.xml
345 chmod 640 openmanod.xml
346 popd > /dev/null
347 #Add the openmanod service to the default zone permanently and reload the firewall configuration
348 firewall-cmd --permanent --add-service=openmanod > /dev/null
349 firewall-cmd --reload > /dev/null
350 echo "done."
351 else
352 echo "skipping."
353 fi
354fi
355
tierno80fde982017-04-26 14:33:25 +0200356echo -e "\n"\
tierno070e95f2017-05-05 15:55:13 +0200357 "#################################################################\n"\
358 "##### CONFIGURE OPENMANO CLIENT #####\n"\
tierno80fde982017-04-26 14:33:25 +0200359 "#################################################################"
tierno26777652016-11-15 17:33:13 +0000360#creates a link at ~/bin if not configured as a service
361if [[ -z "$INSTALL_AS_A_SERVICE" ]]
tiernoc50e5da2016-07-06 17:49:45 +0200362then
tierno26777652016-11-15 17:33:13 +0000363 su $SUDO_USER -c 'mkdir -p ${HOME}/bin'
364 su $SUDO_USER -c 'rm -f ${HOME}/bin/openmano'
365 su $SUDO_USER -c 'rm -f ${HOME}/bin/openmano-report'
366 su $SUDO_USER -c 'rm -f ${HOME}/bin/service-openmano'
tierno070e95f2017-05-05 15:55:13 +0200367 su $SUDO_USER -c "ln -s '${BASEFOLDER}/openmano' "'${HOME}/bin/openmano'
368 su $SUDO_USER -c "ln -s '${BASEFOLDER}/scripts/openmano-report.sh' "'${HOME}/bin/openmano-report'
369 su $SUDO_USER -c "ln -s '${BASEFOLDER}/scripts/service-openmano' "'${HOME}/bin/service-openmano'
tierno26777652016-11-15 17:33:13 +0000370
371 #insert /home/<user>/bin in the PATH
tierno80fde982017-04-26 14:33:25 +0200372 #skiped because normally this is done authomatically when ~/bin exists
tierno26777652016-11-15 17:33:13 +0000373 #if ! su $SUDO_USER -c 'echo $PATH' | grep -q "${HOME}/bin"
374 #then
375 # echo " inserting /home/$SUDO_USER/bin in the PATH at .bashrc"
376 # su $SUDO_USER -c 'echo "PATH=\$PATH:\${HOME}/bin" >> ~/.bashrc'
377 #fi
tierno070e95f2017-05-05 15:55:13 +0200378
379 if [[ $SUDO_USER == root ]]
tiernoc50e5da2016-07-06 17:49:45 +0200380 then
tierno26777652016-11-15 17:33:13 +0000381 if ! echo $PATH | grep -q "${HOME}/bin"
382 then
383 echo "PATH=\$PATH:\${HOME}/bin" >> ${HOME}/.bashrc
384 fi
tierno070e95f2017-05-05 15:55:13 +0200385 fi
tierno26777652016-11-15 17:33:13 +0000386fi
garciadeblas16304ba2016-05-11 14:47:39 +0200387
388#configure arg-autocomplete for this user
389#in case of minimal instalation this package is not installed by default
390[[ "$_DISTRO" == "CentOS" || "$_DISTRO" == "Red" ]] && yum install -y bash-completion
391#su $SUDO_USER -c 'mkdir -p ~/.bash_completion.d'
392su $SUDO_USER -c 'activate-global-python-argcomplete --user'
tiernoc50e5da2016-07-06 17:49:45 +0200393if ! su $SUDO_USER -c 'grep -q bash_completion.d/python-argcomplete.sh ${HOME}/.bashrc'
garciadeblas16304ba2016-05-11 14:47:39 +0200394then
395 echo " inserting .bash_completion.d/python-argcomplete.sh execution at .bashrc"
tiernoc50e5da2016-07-06 17:49:45 +0200396 su $SUDO_USER -c 'echo ". ${HOME}/.bash_completion.d/python-argcomplete.sh" >> ~/.bashrc'
garciadeblas16304ba2016-05-11 14:47:39 +0200397fi
398
Gennadiy Dubina89cb0d12017-04-03 15:46:41 +0300399if [ -z "$NO_DB" ]; then
tierno80fde982017-04-26 14:33:25 +0200400 echo -e "\n"\
tierno070e95f2017-05-05 15:55:13 +0200401 "#################################################################\n"\
402 "##### INSTALL DATABASE SERVER #####\n"\
tierno80fde982017-04-26 14:33:25 +0200403 "#################################################################"
tierno45a52852016-08-26 14:39:42 +0200404
Gennadiy Dubina89cb0d12017-04-03 15:46:41 +0300405 if [ -n "$QUIET_MODE" ]; then
406 DB_QUIET='-q'
407 fi
tierno070e95f2017-05-05 15:55:13 +0200408 ${BASEFOLDER}/database_utils/install-db-server.sh -U $DBUSER ${DBPASSWD_PARAM/p/P} $DB_QUIET $DB_FORCE_UPDATE || exit 1
tierno80fde982017-04-26 14:33:25 +0200409 echo -e "\n"\
tierno070e95f2017-05-05 15:55:13 +0200410 "#################################################################\n"\
411 "##### CREATE AND INIT MANO_VIM DATABASE #####\n"\
tierno80fde982017-04-26 14:33:25 +0200412 "#################################################################"
413 # Install mano_vim_db after setup
414 ${OSMLIBOVIM_PATH}/database_utils/install-db-server.sh -U $DBUSER ${DBPASSWD_PARAM/p/P} -u mano -p manopw -d mano_vim_db --no-install-packages $DB_QUIET $DB_FORCE_UPDATE || exit 1
415fi # [ -z "$NO_DB" ]
tierno45a52852016-08-26 14:39:42 +0200416
tierno26777652016-11-15 17:33:13 +0000417if [[ -n "$INSTALL_AS_A_SERVICE" ]]
tierno45a52852016-08-26 14:39:42 +0200418then
tierno80fde982017-04-26 14:33:25 +0200419 echo -e "\n"\
tierno070e95f2017-05-05 15:55:13 +0200420 "#################################################################\n"\
421 "##### CONFIGURE OPENMANO SERVICE #####\n"\
tierno80fde982017-04-26 14:33:25 +0200422 "#################################################################"
tierno45a52852016-08-26 14:39:42 +0200423
tierno070e95f2017-05-05 15:55:13 +0200424 ${BASEFOLDER}/scripts/install-openmano-service.sh -f ${BASEFOLDER} `[[ -z "$NOCLONE" ]] && echo "-d"`
425 # rm -rf ${BASEFOLDER}
tierno80fde982017-04-26 14:33:25 +0200426 # alias service-openmano="service openmano"
427 # echo 'alias service-openmano="service openmano"' >> ${HOME}/.bashrc
tierno45a52852016-08-26 14:39:42 +0200428 echo
tierno26777652016-11-15 17:33:13 +0000429 echo "Done! installed at /opt/openmano"
Igor D.Cbf669b92017-10-23 13:36:03 +0000430 echo " Manage server with 'sudo -E service osm-ro start|stop|status|...' "
tierno45a52852016-08-26 14:39:42 +0200431else
tierno45a52852016-08-26 14:39:42 +0200432 echo
433 echo "Done! you may need to logout and login again for loading client configuration"
tierno070e95f2017-05-05 15:55:13 +0200434 echo " Run './${BASEFOLDER}/scripts/service-openmano start' for starting openmano in a screen"
tierno45a52852016-08-26 14:39:42 +0200435fi